/* NEVER EVER edit this manually, fix the mkhelp script instead! */
#include <stdio.h>
void hugehelp(void)
{
puts ( 
"                                  _   _ ____  _     \n"
"  Project                     ___| | | |  _ \\| |    \n"
"                             / __| | | | |_) | |    \n"
"                            | (__| |_| |  _ <| |___ \n"
"                             \\___|\\___/|_| \\_\\_____|\n"
"\n"
"NAME\n"
"  curl - get a file from a FTP, GOPHER or HTTP server.\n"
"\n"
"SYNOPSIS\n"
"  curl [options] <url>\n"
" \n"
"DESCRIPTION\n"
"  curl is a client to get documents/files from servers, using any of the\n"
"  supported protocols. The command is designed to work without user\n"
"  interaction or any kind of interactivity.\n"
"\n"
"OPTIONS\n"
"   The following options may be specified at the command line:\n"
"\n"
"   -a   (FTP ONLY)\n"
"        When used in a ftp upload, this will curl to append to the target\n"
"        file instead of overwriting it. If the file doesn't exist, it will\n"
"        be created.\n"
"\n"
"   -A   (HTTP ONLY)\n"
"        Specify the User-Agent string to send to the HTTP server. Some\n"
"        badly done CGIs fail if its not set to \"Mozilla/4.0\".  To encode\n"
"        blanks in the string, surround the string with single quote marks.\n"
"\n"
"   -c   (FTP ONLY)\n"
"	Continue/Resume a previous file transfer. This instructs curl to\n"
"	continue appending data on the file where it was previously left,\n"
"	possibly because of a broken connection to the server. There must be\n"
"	a named physical file to append to for this to work.\n"
"	Note: Upload resume is depening on a command named SIZE not always\n"
"	present in all ftp servers!\n"
"\n"
"   -C <offset> (FTP ONLY)\n"
"	Continue/Resume a previous file transfer at the given offset. The\n"
"	given offset is the exact number of bytes that will be skipped\n"
"	counted from the beginning of the source file before it is transfered\n"
"	to the destination.\n"
"	If used with uploads, the ftp server command SIZE will not be used by\n"
"	curl.\n"
"\n"
"   -d <data> (HTTP ONLY)\n"
"        Sends the specified data in a POST request to the HTTP server. Note\n"
"        that the data is sent exactly as specified with no extra processing.\n"
"        The data is expected to be \"urlencoded\".\n"
"\n"
"   -e <url> (HTTP ONLY)\n"
"        Sends the \"Referer Page\" information to the HTTP server. Some badly\n"
"        done CGIs fail if it's not set.\n"
"\n"
"   -f   (HTTP ONLY)\n"
"        Fail silently (no output at all) on server errors. This is mostly done\n"
"        like this to better enable scripts etc to better deal with failed\n"
"        attempts. In normal cases when a HTTP server fails to deliver a\n"
"        document, it returns a HTML document stating so (which often also\n"
"        describes why and more). This flag will prevent curl from\n"
"        outputting that and fail silently instead.\n"
"\n"
"   -i   (HTTP ONLY)\n"
"        Include the HTTP-header in the output. The HTTP-header includes things\n"
"        like server-name, date of the document, HTTP-version and more...\n"
"\n"
"   -I   (HTTP ONLY)\n"
"        Fetch the HTTP-header only! HTTP-servers feature the command HEAD\n"
"        which this uses to get nothing but the header of a document.\n"
"\n"
"   -k   (HTTP ONLY)\n"
"        Use Keep-Alive connection. There is currently no real gain to use\n"
"        this.\n"
"\n"
"   -l   (FTP ONLY)\n"
"        When listing an FTP directory, this switch forces a name-only view.\n"
"        Especially useful if you want to machine-parse the contents of an FTP\n"
"        directory since the normal directory view doesn't use a standard look\n"
"        or format.\n"
"\n"
"   -m <seconds>\n"
"        Maximum time in seconds that you allow the whole operation to take.\n"
"        This is useful for preventing your batch jobs from hanging for hours\n"
"        due to slow networks or links going down.\n"
"\n"
"   -n\n"
"	Makes curl scan the .netrc file in the user's home directory for\n"
"	login name and password. This is typically used for ftp on unix, but\n"
"	if used with http and curl user authentication will be switched\n"
"	on. See man netrc(4) for details on the file format. Curl will not\n"
"	complain if that file hasn't the right permissions (it should not be\n"
"	world nor group readable). The environment variable \"HOME\" is used\n"
"	to find the home directory.\n"
"\n"
"   -o <file>\n"
"        Write output to <file> instead of stdout.\n"
"\n"
"   -O\n"
"        Write output to a local file named like the remote file we get. (Only\n"
"        the file part of the remote file is used, the path is cut off.)\n"
"\n"
"   -r <range>   (HTTP ONLY)\n"
"        Retrieve a byte range (i.e a partial document) from a HTTP/1.1\n"
"        server. Ranges can be specified in a number of ways.\n"
"        0-499           - specifies the first 500 bytes\n"
"        500-999         - specifies the second 500 bytes\n"
"        -500            - specifies the last 500 bytes\n"
"        9500-           - specifies the bytes from offset 9500 and forward\n"
"        0-0,-1          - specifies the first and last byte only(*)\n"
"        500-700,600-799 - specifies 300 bytes from offset 500\n"
"        100-199,500-599 - specifies two separate 100 bytes ranges(*)\n"
"\n"
"        (*) = NOTE that this will cause the server to reply with a multipart\n"
"        response!\n"
"\n"
"   -p <port>\n"
"        Use port other than default for current protocol. This is typically\n"
"        most used together with the proxy-flag (-x).\n"
"\n"
"   -P <address> (FTP ONLY)\n"
"	Reverses the initiator/listenor roles when connecting with ftp. This\n"
"	switch makes Curl use the PORT command instead of PASV. In\n"
"	practice, PORT tells the server to connect to the client's specified\n"
"	address and port, while PASV asks the server for an ip address and\n"
"	port to connect to. <address> should be one of:\n"
"          interface - i.e \"eth0\" to specify which interface's IP address you\n"
"                      want to use  (Unix only)\n"
"          IP address - i.e \"192.168.10.1\" to specify exact IP number\n"
"          host name - i.e \"my.host.domain\" to specify machine\n"
"          \"-\"       - (any single-letter string) to make it pick the machine's\n"
"                      default\n"
"\n"
"   -s\n"
"        Silent mode. Don't show progress meter or error messages.  Makes\n"
"        Curl mute.\n"
"\n"
"   -sl <speed>\n"
"	Speed Limit. If a download is slower than this given speed, in bytes\n"
"	per second, for Speed Time seconds it gets aborted. Speed Time is set\n"
"	with -st and is 30 if not set.\n"
"\n"
"   -st <time>\n"
"	Speed Time. If a download is slower than Speed Limit bytes per second\n"
"	during a Speed Time period, the download gets aborted. If Speed Time\n"
"	is used, the default Speed Limit will be 1 unless set with -sl.\n"
"\n"
"   -t  (FTP only)\n"
"	Transfer the stdin data to the specified file. Curl will read\n"
"	everything from stdin until EOF and store with the supplied name.\n"
"\n"
"   -T <file> (FTP)\n"
"        Like -t, but this transfers the specified local file. If there is no\n"
"        file part in the specified URL, Curl will append the local file\n"
"        name. NOTE that you must use a trailing / on the last directory to\n"
"        really prove to Curl that there is no file name or curl will\n"
"        think that your last directory name is the remote file name to\n"
"        use. That will most likely cause the upload operation to fail.\n"
"\n"
"   -T <file> (HTTP and HTTPS)\n"
"        Specify a file containing raw HTTP comands. Typically, this file\n"
"        will have a POST header including Content-Type and Content-Length\n"
"        fields, and then a blank line followed by POST data.\n"
"\n"
"   -u <user:password>\n"
"        Specify user and password to use when fetching. See below for detailed\n"
"        examples of how to use this.\n"
"\n"
"   -U <user:password>\n"
"        Specify user and password to use for Proxy authentication.\n"
"\n"
"   -v \n"
"        Makes the fetching more verbose/talkative. Mostly usable for\n"
"        debugging. Lines starting with '>' means data sent by curl, '<'\n"
"        means data received by curl that is hidden in normal cases and lines\n"
"	starting with '*' means additional info provided by curl.\n"
"\n"
"   -x <proxyhost>\n"
"   -x <proxyhost:proxyport>\n"
"        Use proxy. If the proxyport is not specified, and the -p flag is not\n"
"        used, it is assumed the proxy is at port 1080.  If the -p flag is\n"
"        used, then that indicated port number is assumed to be the proxy port\n"
"        number.\n"
"\n"
"SIMPLE USAGE\n"
"\n"
"  Get the main page from netscape's web-server:\n"
"\n"
"        curl http://www.netscape.com/\n"
"\n"
"  Get the root README file from funet's ftp-server:\n"
"\n"
"        curl ftp://ftp.funet.fi/README\n"
"\n"
"  Get a gopher document from funet's gopher server:\n"
"\n"
"        curl gopher://gopher.funet.fi\n"
"\n"
"  Get a web page from a server using port 8000:\n"
"\n"
"        curl http://www.weirdserver.com:8000/\n"
"\n"
"  Get a list of the root directory of an FTP site:\n"
"\n"
"        curl ftp://ftp.fts.frontec.se/\n"
"\n"
"DOWNLOAD TO A FILE\n"
"\n"
"  Get a web page and store in a local file:\n"
"\n"
"        curl -o thatpage.html http://www.netscape.com/\n"
"\n"
"  Get a web page and store in a local file, make the local file get the name\n"
"  of the remote document (if no file name part is specified in the URL, this\n"
"  will fail):\n"
"\n"
"        curl -O http://www.netscape.com/index.html\n"
"\n"
"USING PASSWORDS\n"
"\n"
" FTP\n"
"\n"
"   To ftp files using name+passwd, include them in the URL like:\n"
"\n"
"        curl ftp://name:passwd@machine.domain:port/full/path/to/file\n"
"\n"
"   or specify them with the -u flag like\n"
"\n"
"        curl -u name:passwd ftp://machine.domain:port/full/path/to/file\n"
"\n"
" HTTP\n"
"\n"
"   The HTTP URL doesn't support user and password in the URL string. Curl\n"
"   does support that anyway to provide a ftp-style interface and thus you can\n"
"   pick a file like:\n"
"\n"
"        curl http://name:passwd@machine.domain/full/path/to/file\n"
"\n"
"   or specify user and password separately like in\n"
"\n"
"        curl -u name:passwd http://machine.domain/full/path/to/file\n"
"\n"
"   NOTE! Since HTTP URLs don't support user and password, you can't use that\n"
"   style when using Curl via a proxy. You _must_ use the -u style fetch\n"
"   during such circumstances.\n"
"\n"
" GOPHER\n"
"\n"
"   Curl features no password support for gopher.\n"
"\n"
"PROXY\n"
"\n"
" Get a web page using a proxy named my-proxy that uses port 888:\n"
"\n"
"        curl -p 888 -x my-proxy http://www.web.com/\n"
"\n"
" Get an ftp file using a proxy named my-proxy that uses port 888:\n"
"\n"
"        curl -p 888 -x my-proxy ftp://ftp.leachsite.com/README\n"
"\n"
" Get a file from a HTTP server that requires user and password, using the\n"
" same proxy as above:\n"
"\n"
"        curl -u user:passwd -p 888 -x my-proxy http://www.get.this/\n"
"\n"
"RANGES\n"
"\n"
"  With HTTP 1.1 byte-ranges were introduced. Using this, a client can request\n"
"  to get only one or more subparts of a specified document. Curl supports\n"
"  this with the -r flag.\n"
"\n"
"  Get the first 100 bytes of a document:\n"
"\n"
"        curl -r 0-99 http://www.get.this/\n"
"\n"
"  Get the last 500 bytes of a document:\n"
"\n"
"        curl -r -500 http://www.get.this/\n"
"\n"
"UPLOADING\n"
"\n"
" FTP\n"
"\n"
"   Upload all data on stdin to a specified ftp site:\n"
"\n"
"        curl -t ftp://ftp.upload.com/myfile\n"
"\n"
"   Upload data from a specified file, login with user and password:\n"
"\n"
"        curl -T uploadfile -u user:passwd ftp://ftp.upload.com/myfile\n"
"\n"
"   Upload a local file to the remote site, and use the local file name remote\n"
"   too:\n"
" \n"
"        curl -T uploadfile -u user:passwd ftp://ftp.upload.com/\n"
"\n"
" HTTP\n"
"\n"
"   See the POST section below.\n"
"\n"
"VERBOSE / DEBUG\n"
"\n"
"  If curl fails where it isn't supposed to, if the servers don't let you\n"
"  in, if you can't understand the responses: use the -v flag to get VERBOSE\n"
"  fetching. Curl will output lots of info and all data it sends and\n"
"  receives in order to let the user see all client-server interaction.\n"
"\n"
"        curl -v ftp://ftp.upload.com/\n"
"\n"
"POST\n"
"\n"
"  It's easy to post data using curl. This is done using the -d <data>\n"
"  option.  The post data must be urlencoded.\n"
"\n"
"  Post a simple \"name\" and \"phone\" guestbook.\n"
"\n"
"  curl -d \"name=Rafael%20Sagula&phone=3320780\" http://www.where.com/guest.cgi\n"
"\n"
"REFERER\n"
"\n"
"  A HTTP request has the option to include information about which address\n"
"  that referred to actual page, and curl allows the user to specify that\n"
"  referrer to get specified on the command line. It is especially useful to\n"
"  fool or trick stupid servers or CGI scripts that rely on that information\n"
"  being available or contain certain data.\n"
"\n"
"	curl -e www.coolsite.com http://www.showme.com/\n"
"\n"
"USER AGENT\n"
"\n"
"  A HTTP request has the option to include information about the browser\n"
"  that generated the request. Curl allows it to be specified on the command\n"
"  line. It is especially useful to fool or trick stupid servers or CGI\n"
"  scripts that only accept certain browsers.\n"
"\n"
"  Example:\n"
"\n"
"  curl -A 'Mozilla/3.0 (Win95; I)' http://www.nationsbank.com/\n"
"\n"
"  Other common strings:\n"
"    'Mozilla/3.0 (Win95; I)'     Netscape Version 3 for Windows 95\n"
"    'Mozilla/3.04 (Win95; U)'    Netscape Version 3 for Windows 95\n"
"    'Mozilla/2.02 (OS/2; U)'     Netscape Version 2 for OS/2\n"
"    'Mozilla/4.04 [en] (X11; U; AIX 4.2; Nav)'           NS for AIX\n"
"    'Mozilla/4.05 [en] (X11; U; Linux 2.0.32 i586)'      NS for Linux\n"
"\n"
"  Note that Internet Explorer tries hard to be compatible in every way:\n"
"    'Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)'    MSIE for W95\n"
"\n"
"  Mozilla is not the only possible User-Agent name:\n"
"    'Konqueror/1.0'             KDE File Manager desktop client\n"
"    'Lynx/2.7.1 libwww-FM/2.14' Lynx command line browser\n"
"\n"
"PROGRESS METER\n"
"\n"
"  The progress meter was introduced to better show a user that something\n"
"  actually is happening. The different fields in the output have the following\n"
"  meaning:\n"
"\n"
"   %   Received   Total  Speed   Time left  Total   Curr.Speed\n"
"  13   524140   3841536   4296   0:12:52   0:14:54    292     \n"
"\n"
"  From left-to-right:\n"
"  - The first column, is the percentage of the file currently transfered.\n"
"  - Received means the total number of bytes that has been transfered.\n"
"  - Total is the total number of bytes expected to transfer.\n"
"  - Speed is average speed in bytes per second for the whole transfer so far.\n"
"  - Time left is the estimated time left for this transfer to finnish if the\n"
"    current average speed will remain steady.\n"
"  - Total is the estimated total transfer time.\n"
"  - Curr.Speed is the average transfer speed the last 5 seconds (the first\n"
"    5 seconds of a transfer is based on less time of course.)\n"
"\n"
"  NOTE: Much of the output is based on the fact that the size of the transfer\n"
"  is known before it takes place. If it isn't, a much less fancy display will\n"
"  be used.\n"
"\n"
"SPEED LIMIT\n"
"\n"
"  Curl offers the user to set conditions regarding transfer speed that must\n"
"  be met to let the transfer keep going. By using the switch -sl and -st you\n"
"  can make curl abort transfers if the transfer speed doesn't exceed your\n"
"  given lowest limit for a specified time.\n"
"\n"
"  To let curl abandon downloading this page if its slower than 3000 bytes per\n"
"  second for 1 minute, run:\n"
"\n"
"	curl -sl 3000 -st 60 www.far-away-site.com\n"
"\n"
"  This can very well be used in combination with the overall time limit, so\n"
"  that the above operatioin must be completed in whole within 30 minutes:\n"
"\n"
"	curl -m 1800 -sl 3000 -st 60 www.far-away-site.com\n"
"\n"
"BUGS\n"
"  Nope. :-) But don't try excessive string lengths, we don't do many boundary\n"
"  checks so those will without doubt crash this.\n"
"\n"
"  Well, if you do find any (or have other suggestions), mail Daniel Stenberg\n"
"  <Daniel.Stenberg@sth.frontec.se>.\n"
"\n"
"VERSION\n"
"  This document attempts to describe the usage of curl 4.7 and later.\n"
"  Written by Daniel Stenberg and Linas Vepstas.\n"
"\n"
"AUTHORS\n"
"  Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>\n"
"  Rafael Sagula <sagula@inf.ufrgs.br>\n"
"  Sampo Kellomaki <sampo@iki.fi>\n"
"  Linas Vepstas <linas@linas.org>\n"
"  Bjorn Reese <breese@imada.ou.dk>\n"
"  Johan Anderson <johan@homemail.com>\n"
"  Kjell Ericson <Kjell.Ericson@sth.frontec.se>\n"
"    \n"
"WWW\n"
"  http://www.fts.frontec.se/~dast/curl/\n"
"  http://www.inf.ufrgs.br/~sagula/urlget.html\n"
 ) ; 
}
